unit eBob42.NicerLabelControl;
// To create a more advanced Web Control that supports live data at
// design time, see instructions in the readme file located in the
// 'BDS\3.0\Source\dotNet\dbwebcontrols' directory

interface

uses
  System.Web.UI, System.Web.UI.WebControls,
  System.ComponentModel, System.Drawing;

type
  /// <summary>
  /// Summary description for MyWebControl1.
  /// </summary>
  [DefaultProperty('Text'),
   ToolboxData('<{0}:NicerLabelControl runat=server></{0}:NicerLabelControl>')]
  NicerLabelControl = class(System.Web.UI.WebControls.WebControl)
  strict private
    FText: String;
  private
    FForeColorEnd: Color;
  strict protected
    // override RenderContents(..) when you inherit from Web.UI.WebControls.WebControl
    procedure RenderContents(Output: HtmlTextWriter); override;

   // override Render(..) when you inherit from Web.UI.WebControls.Control
   // procedure Render(Output: HtmlTextWriter); override;
  public
    constructor Create;
  published
    [Bindable(true),
     Category('Appearance'),
     DefaultValue('')]
    property Text: string read FText write FText;
    property ForeColorEnd: Color read FForeColorEnd write FForeColorEnd;
  end;

implementation

/// <summary>
/// Define a public parameterless constructor needed by web controls.
/// </summary>
constructor NicerLabelControl.Create;
begin
  inherited;
end;

/// <summary>
/// Render this control to the output parameter specified, preserving
/// cosmetic attribute output generation inherited from standard WebControl.
/// </summary>
/// <param name="output"> The HTML writer to write out to </param>
procedure NicerLabelControl.RenderContents(Output: HtmlTextWriter);
type
  Str2 = String[2];
var
  Red,RedD,
  Green,GreenD,
  Blue,BlueD: Integer; { from ForeColor to ForeColorEnd }
  Len,i: Integer;

  function Int2Hex(X: Byte): Str2;
  const
    H: array[0..$F] of Char = '0123456789ABCDEF';
  begin
    Result := H[X div $10] + H[X mod $10]
  end;

begin
  Red := ForeColor.R;
  Green := ForeColor.G;
  Blue := ForeColor.B;
  Len := Length(Text)-1;
  if Len > 0 then
  begin
    RedD := Round((ForeColorEnd.R - ForeColor.R) / Len);
    GreenD := Round((ForeColorEnd.G - ForeColor.G) / Len);
    BlueD := Round((ForeColorEnd.B - ForeColor.B) / Len);
  end;
  for i:=1 to Length(Text) do
  begin
    Output.Write('<font color=#' +
      Int2Hex(Red) + Int2Hex(Green) + Int2Hex(Blue) +
      '>' + FText[i] + '</font>');
    Inc(Red,RedD);
    Inc(Green,GreenD);
    Inc(Blue,BlueD)
  end
end;

{$REGION 'Render override'}
(*
/// <summary>
/// Render this control to the output parameter specified.
/// </summary>
/// <param name="output"> The HTML writer to write out to </param>
procedure MyWebControl1.Render(Output: HtmlTextWriter);
begin
  Output.Write(Text);
end;
(* *)
{$ENDREGION}

end.
