unit eBob42.NiceLabel;
interface
uses
  System.Web.UI, System.Web.UI.WebControls,
  System.ComponentModel;

type
  /// <summary>
  /// Summary description for NiceLabel.
  /// </summary>
  [DefaultProperty('Text'),
   ToolboxData('<{0}:NiceLabel runat=server></{0}:NiceLabel>')]
  NiceLabel = class(System.Web.UI.Control)
  strict private
    FText: String;
  strict protected
   // override Render(..) when you inherit from Web.UI.WebControls.Control
   procedure Render(Output: HtmlTextWriter); override;
  public
    constructor Create;
  published
    [Bindable(true),
     Category('Appearance'),
     DefaultValue('')]
    property Text: string read FText write FText;
  end;

implementation

/// <summary>
/// Define a public parameterless constructor needed by web controls.
/// </summary>
constructor NiceLabel.Create;
begin
  inherited;
end;

{$REGION 'Render override'}
/// <summary>
/// Render this control to the output parameter specified.
/// </summary>
/// <param name="output"> The HTML writer to write out to </param>
procedure NiceLabel.Render(Output: HtmlTextWriter);
begin
  Output.Write(Text);
end;
{$ENDREGION}

end.
